<script setup lang="ts">
    import { RouteRecordRaw, useRouter } from 'vue-router'
    import { useDisplay } from 'vuetify'
    import { useRoute } from '@/router/useRoute'
    import { ref } from 'vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'

    export interface Props {
        pageTitle: string
        showTitle?: boolean
    }

    withDefaults(defineProps<Props>(), {
        showTitle: true,
    })

    const router = useRouter()
    const administrationRoute = useRoute('admin')
    const administrationRouteListInMenu: RouteRecordRaw[] = []

    administrationRoute?.children.forEach((group: RouteRecordRaw) => {
        group.children?.forEach((route: RouteRecordRaw) => {
            if (route.path === '') {
                administrationRouteListInMenu.push(route)
            }
        })
    })

    const { mobile } = useDisplay()
    const isDrawerOpen = ref(!mobile.value)
</script>

<template>
    <s-contextual-navbar
        :page-title="$props.pageTitle"
        :show-title="$props.showTitle"
    >
        <template #contextualButtons>
            <slot name="searchField"></slot>
            <v-btn
                v-if="mobile"
                icon="mdi-menu"
                color="on-background"
                data-cy="btn-silab-admin-toggle-menu"
                @click="isDrawerOpen = !isDrawerOpen"
            ></v-btn>
        </template>
    </s-contextual-navbar>
    <v-navigation-drawer v-model="isDrawerOpen" :permanent="!mobile">
        <v-list>
            <v-list-item
                v-for="routeShowInMenu in administrationRouteListInMenu"
                :key="routeShowInMenu.path"
                :data-cy="`btn-silab-admin-menu-item-${
                    routeShowInMenu.name?.toString() ?? ''
                }`"
                variant="text"
                :value="routeShowInMenu.name"
                :prepend-icon="routeShowInMenu.meta?.icon as string | undefined"
                :active="
                    $router.currentRoute.value.name === routeShowInMenu.name
                "
                @click="router.push({ name: routeShowInMenu.name })"
            >
                {{ routeShowInMenu.meta?.title }}
            </v-list-item>
        </v-list>
    </v-navigation-drawer>
</template>
